diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-mac.h ns-3.44/src/wifi/model/wifi-mac.h
--- ns-3.43/src/wifi/model/wifi-mac.h	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-mac.h	2025-03-09 16:55:49.803372600 -0700
@@ -671,60 +685,66 @@
         std::optional<std::reference_wrapper<const RecipientBlockAckAgreement>>;
 
     /**
-     * \param recipient (link or device) MAC address of the recipient
-     * \param tid traffic ID.
+     * @param recipient (link or device) MAC address of the recipient
+     * @param tid traffic ID
+     * @param gcrGroupAddr the GCR Group Address (only if it is a GCR Block Ack agreement)
      *
-     * \return the originator block ack agreement, if one has been established
+     * @return the originator block ack agreement, if one has been established
      *
      * Checks if an originator block ack agreement is established with station addressed by
      * <i>recipient</i> for TID <i>tid</i>.
      */
-    OriginatorAgreementOptConstRef GetBaAgreementEstablishedAsOriginator(Mac48Address recipient,
-                                                                         uint8_t tid) const;
-    /**
-     * \param originator (link or device) MAC address of the originator
-     * \param tid traffic ID.
+    OriginatorAgreementOptConstRef GetBaAgreementEstablishedAsOriginator(
+        Mac48Address recipient,
+        uint8_t tid,
+        std::optional<Mac48Address> gcrGroupAddr = std::nullopt) const;
+    /**
+     * @param originator (link or device) MAC address of the originator
+     * @param tid traffic ID
+     * @param gcrGroupAddr the GCR Group Address (only if it is a GCR Block Ack agreement)
      *
-     * \return the recipient block ack agreement, if one has been established
+     * @return the recipient block ack agreement, if one has been established
      *
      * Checks if a recipient block ack agreement is established with station addressed by
      * <i>originator</i> for TID <i>tid</i>.
      */
-    RecipientAgreementOptConstRef GetBaAgreementEstablishedAsRecipient(Mac48Address originator,
-                                                                       uint8_t tid) const;
+    RecipientAgreementOptConstRef GetBaAgreementEstablishedAsRecipient(
+        Mac48Address originator,
+        uint8_t tid,
+        std::optional<Mac48Address> gcrGroupAddr = std::nullopt) const;
 
     /**
-     * \param recipient MAC address
-     * \param tid traffic ID
+     * @param recipient MAC address
+     * @param tid traffic ID
      *
-     * \return the type of Block Acks sent by the recipient
+     * @return the type of Block Acks sent by the recipient
      *
      * This function returns the type of Block Acks sent by the recipient.
      */
     BlockAckType GetBaTypeAsOriginator(const Mac48Address& recipient, uint8_t tid) const;
     /**
-     * \param recipient MAC address of recipient
-     * \param tid traffic ID
+     * @param recipient MAC address of recipient
+     * @param tid traffic ID
      *
-     * \return the type of Block Ack Requests sent to the recipient
+     * @return the type of Block Ack Requests sent to the recipient
      *
      * This function returns the type of Block Ack Requests sent to the recipient.
      */
     BlockAckReqType GetBarTypeAsOriginator(const Mac48Address& recipient, uint8_t tid) const;
     /**
-     * \param originator MAC address of originator
-     * \param tid traffic ID
+     * @param originator MAC address of originator
+     * @param tid traffic ID
      *
-     * \return the type of Block Acks sent to the originator
+     * @return the type of Block Acks sent to the originator
      *
      * This function returns the type of Block Acks sent to the originator.
      */
     BlockAckType GetBaTypeAsRecipient(Mac48Address originator, uint8_t tid) const;
     /**
-     * \param originator MAC address of originator
-     * \param tid traffic ID
+     * @param originator MAC address of originator
+     * @param tid traffic ID
      *
-     * \return the type of Block Ack Requests sent by the originator
+     * @return the type of Block Ack Requests sent by the originator
      *
      * This function returns the type of Block Ack Requests sent by the originator.
      */
@@ -734,30 +754,42 @@
      * Get the maximum Block Ack buffer size (in number of MPDUs) supported by the given device,
      * if any, or by this device, otherwise, based on the supported standard.
      *
-     * \param address the (MLD or link) address of the given device
-     * \return the maximum supported Block Ack buffer size (in number of MPDUs)
+     * @param address the (MLD or link) address of the given device
+     * @return the maximum supported Block Ack buffer size (in number of MPDUs)
      */
     uint16_t GetMaxBaBufferSize(std::optional<Mac48Address> address = std::nullopt) const;
 
     /**
-     * \param size the size (in number of MPDUs) of the buffer used for each BlockAck
+     * @param size the size (in number of MPDUs) of the buffer used for each BlockAck
      *             agreement in which this node is a recipient
      */
     void SetMpduBufferSize(uint16_t size);
 
     /**
-     * \return the size (in number of MPDUs) of the buffer used for each BlockAck
+     * @return the size (in number of MPDUs) of the buffer used for each BlockAck
      *             agreement in which this node is a recipient
      */
     uint16_t GetMpduBufferSize() const;
 
     /**
+     * Set the frame retry limit.
+     *
+     * @param limit the frame retry limit
+     */
+    void SetFrameRetryLimit(uint32_t limit);
+
+    /**
+     * @return the frame retry limit
+     */
+    uint32_t GetFrameRetryLimit() const;
+
+    /**
      * Get the TID-to-Link Mapping negotiated with the given MLD (if any) for the given direction.
      * An empty mapping indicates the default mapping.
      *
-     * \param mldAddr the MLD address of the given MLD
-     * \param dir the given direction (DL or UL)
-     * \return the negotiated TID-to-Link Mapping
+     * @param mldAddr the MLD address of the given MLD
+     * @param dir the given direction (DL or UL)
+     * @return the negotiated TID-to-Link Mapping
      */
     std::optional<std::reference_wrapper<const WifiTidLinkMapping>> GetTidToLinkMapping(
         Mac48Address mldAddr,
@@ -767,11 +799,11 @@
      * Check whether the given TID is mapped on the given link in the given direction for the
      * given MLD.
      *
-     * \param mldAddr the MLD address of the given MLD
-     * \param dir the given direction (DL or UL)
-     * \param tid the given TID
-     * \param linkId the ID of the given link
-     * \return whether the given TID is mapped on the given link in the given direction for the
+     * @param mldAddr the MLD address of the given MLD
+     * @param dir the given direction (DL or UL)
+     * @param tid the given TID
+     * @param linkId the ID of the given link
+     * @return whether the given TID is mapped on the given link in the given direction for the
      *         given MLD
      */
     bool TidMappedOnLink(Mac48Address mldAddr,
@@ -785,8 +817,8 @@
     void NotifyConstructionCompleted() override;
 
     /**
-     * \param cwMin the minimum contention window size
-     * \param cwMax the maximum contention window size
+     * @param cwMin the minimum contention window size
+     * @param cwMax the maximum contention window size
      *
      * This method is called to set the minimum and the maximum
      * contention window size.
@@ -796,37 +828,37 @@
     /**
      * Enable or disable short slot time feature.
      *
-     * \param enable true if short slot time is to be supported,
+     * @param enable true if short slot time is to be supported,
      *               false otherwise
      */
     void SetShortSlotTimeSupported(bool enable);
     /**
-     * \return whether the device supports short slot time capability.
+     * @return whether the device supports short slot time capability.
      */
     bool GetShortSlotTimeSupported() const;
 
     /**
      * Accessor for the AC_VO channel access function
      *
-     * \return a smart pointer to QosTxop
+     * @return a smart pointer to QosTxop
      */
     Ptr<QosTxop> GetVOQueue() const;
     /**
      * Accessor for the AC_VI channel access function
      *
-     * \return a smart pointer to QosTxop
+     * @return a smart pointer to QosTxop
      */
     Ptr<QosTxop> GetVIQueue() const;
     /**
      * Accessor for the AC_BE channel access function
      *
-     * \return a smart pointer to QosTxop
+     * @return a smart pointer to QosTxop
      */
     Ptr<QosTxop> GetBEQueue() const;
     /**
      * Accessor for the AC_BK channel access function
      *
-     * \return a smart pointer to QosTxop
+     * @return a smart pointer to QosTxop
      */
     Ptr<QosTxop> GetBKQueue() const;
 
@@ -847,16 +879,16 @@
      * buffered MPDU has been received on); in such a cases, the value
      * of <i>linkId</i> should be WIFI_LINKID_UNDEFINED.
      *
-     * \param mpdu the MPDU that has been received.
-     * \param linkId the ID of the given link
+     * @param mpdu the MPDU that has been received.
+     * @param linkId the ID of the given link
      */
     virtual void Receive(Ptr<const WifiMpdu> mpdu, uint8_t linkId);
     /**
      * Forward the packet up to the device.
      *
-     * \param packet the packet that we are forwarding up to the device
-     * \param from the address of the source
-     * \param to the address of the destination
+     * @param packet the packet that we are forwarding up to the device
+     * @param from the address of the source
+     * @param to the address of the destination
      */
     void ForwardUp(Ptr<const Packet> packet, Mac48Address from, Mac48Address to);
 
@@ -864,7 +896,7 @@
      * This method can be called to de-aggregate an A-MSDU and forward
      * the constituent packets up the stack.
      *
-     * \param mpdu the MPDU containing the A-MSDU.
+     * @param mpdu the MPDU containing the A-MSDU.
      */
     virtual void DeaggregateAmsduAndForward(Ptr<const WifiMpdu> mpdu);
 
@@ -872,8 +904,8 @@
      * Apply the TID-to-Link Mapping negotiated with the given MLD for the given direction
      * by properly configuring the queue scheduler.
      *
-     * \param mldAddr the MLD MAC address of the given MLD
-     * \param dir the given direction (DL or UL)
+     * @param mldAddr the MLD MAC address of the given MLD
+     * @param dir the given direction (DL or UL)
      */
     void ApplyTidLinkMapping(const Mac48Address& mldAddr, WifiDirection dir);
 
@@ -882,7 +914,7 @@
      * is normally called by a non-AP MLD upon completing ML setup to have its link IDs
      * match AP MLD's link IDs.
      *
-     * \param links a set of pairs (from, to) each mapping a current link ID to the
+     * @param links a set of pairs (from, to) each mapping a current link ID to the
      *              link ID it has to become (i.e., link 'from' becomes link 'to')
      */
     void SwapLinks(std::map<uint8_t, uint8_t> links);
@@ -909,15 +941,15 @@
     };
 
     /**
-     * \return a const reference to the map of link entities
+     * @return a const reference to the map of link entities
      */
     const std::map<uint8_t, std::unique_ptr<LinkEntity>>& GetLinks() const;
 
     /**
      * Get a reference to the link associated with the given ID.
      *
-     * \param linkId the given link ID
-     * \return a reference to the link associated with the given ID
+     * @param linkId the given link ID
+     * @return a reference to the link associated with the given ID
      */
     LinkEntity& GetLink(uint8_t linkId) const;
 
@@ -925,9 +957,9 @@
      * Update the TID-to-Link Mappings for the given MLD in the given direction based on the
      * given negotiated mappings. An empty mapping indicates the default mapping.
      *
-     * \param mldAddr the MLD address of the given MLD
-     * \param dir the given direction (DL or UL)
-     * \param mapping the negotiated TID-to-Link Mapping
+     * @param mldAddr the MLD address of the given MLD
+     * @param dir the given direction (DL or UL)
+     * @param mapping the negotiated TID-to-Link Mapping
      */
     void UpdateTidToLinkMapping(const Mac48Address& mldAddr,
                                 WifiDirection dir,
@@ -953,11 +985,11 @@
     virtual void DoCompleteConfig() = 0;
 
     /**
-     * \param dcf the DCF to be configured
-     * \param cwmin the minimum contention window for the DCF
-     * \param cwmax the maximum contention window for the DCF
-     * \param isDsss vector of flags to indicate whether PHY is DSSS or HR/DSSS for every link
-     * \param ac the access category for the DCF
+     * @param dcf the DCF to be configured
+     * @param cwmin the minimum contention window for the DCF
+     * @param cwmax the maximum contention window for the DCF
+     * @param isDsss vector of flags to indicate whether PHY is DSSS or HR/DSSS for every link
+     * @param ac the access category for the DCF
      *
      * Configure the DCF with appropriate values depending on the given access category.
      */
@@ -970,7 +1002,7 @@
     /**
      * Configure PHY dependent parameters such as CWmin and CWmax on the given link.
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     void ConfigurePhyDependentParameters(uint8_t linkId);
 
@@ -978,7 +1010,7 @@
      * Enable or disable QoS support for the device. Construct a Txop object or QosTxop objects
      * accordingly. This method is private so that it is only used while constructing this object.
      *
-     * \param enable whether QoS is supported
+     * @param enable whether QoS is supported
      */
     void SetQosSupported(bool enable);
 
@@ -986,7 +1018,7 @@
      * Set the Txop object.
      * This method is private so that it is only used while constructing this object.
      *
-     * \param dcf the Txop object
+     * @param dcf the Txop object
      */
     void SetTxop(Ptr<Txop> dcf);
 
@@ -994,7 +1026,7 @@
      * Set the AC_VO channel access function
      * This method is private so that it is only used while constructing this object.
      *
-     * \param edca the QosTxop object for AC_VO
+     * @param edca the QosTxop object for AC_VO
      */
     void SetVoQueue(Ptr<QosTxop> edca);
 
@@ -1002,7 +1034,7 @@
      * Set the AC_VI channel access function
      * This method is private so that it is only used while constructing this object.
      *
-     * \param edca the QosTxop object for AC_VI
+     * @param edca the QosTxop object for AC_VI
      */
     void SetViQueue(Ptr<QosTxop> edca);
 
@@ -1010,7 +1042,7 @@
      * Set the AC_BE channel access function
      * This method is private so that it is only used while constructing this object.
      *
-     * \param edca the QosTxop object for AC_BE
+     * @param edca the QosTxop object for AC_BE
      */
     void SetBeQueue(Ptr<QosTxop> edca);
 
@@ -1018,7 +1050,7 @@
      * Set the AC_BK channel access function
      * This method is private so that it is only used while constructing this object.
      *
-     * \param edca the QosTxop object for AC_BK
+     * @param edca the QosTxop object for AC_BK
      */
     void SetBkQueue(Ptr<QosTxop> edca);
 
@@ -1032,22 +1064,22 @@
      * This method is a private utility invoked to configure the channel
      * access function for the specified Access Category.
      *
-     * \param ac the Access Category of the queue to initialise.
+     * @param ac the Access Category of the queue to initialise.
      */
     void SetupEdcaQueue(AcIndex ac);
 
     /**
      * If no link has been already created, create the given number links; otherwise, do nothing.
      *
-     * \param nLinks the given number of links
-     * \return whether the given number of links have been created
+     * @param nLinks the given number of links
+     * @return whether the given number of links have been created
      */
     bool CreateLinksIfNeeded(std::size_t nLinks);
 
     /**
      * Create a LinkEntity object.
      *
-     * \return a unique pointer to the created LinkEntity object
+     * @return a unique pointer to the created LinkEntity object
      */
     virtual std::unique_ptr<LinkEntity> CreateLinkEntity() const;
 
@@ -1056,7 +1088,7 @@
      * link ID stored by the Frame Exchange Manager and the Channel Access Manager operating
      * on that link.
      *
-     * \param id the (new) ID of the link that has changed ID
+     * @param id the (new) ID of the link that has changed ID
      */
     void UpdateLinkId(uint8_t id);
 
@@ -1066,80 +1098,80 @@
      * given MAC address. This method is overridden because its implementation depends
      * on the type of station.
      *
-     * \param remoteAddr the MAC address of the remote single link device
-     * \return the MAC address of the affiliated STA used to communicate with the remote device
+     * @param remoteAddr the MAC address of the remote single link device
+     * @return the MAC address of the affiliated STA used to communicate with the remote device
      */
     virtual Mac48Address DoGetLocalAddress(const Mac48Address& remoteAddr) const;
 
     /**
      * Enable or disable ERP support for the given link.
      *
-     * \param enable whether ERP is supported
-     * \param linkId the ID of the given link
+     * @param enable whether ERP is supported
+     * @param linkId the ID of the given link
      */
     void SetErpSupported(bool enable, uint8_t linkId);
     /**
      * Enable or disable DSSS support for the given link.
      *
-     * \param enable whether DSSS is supported
-     * \param linkId the ID of the given link
+     * @param enable whether DSSS is supported
+     * @param linkId the ID of the given link
      */
     void SetDsssSupported(bool enable, uint8_t linkId);
 
     /**
      * Set the block ack threshold for AC_VO.
      *
-     * \param threshold the block ack threshold for AC_VO.
+     * @param threshold the block ack threshold for AC_VO.
      */
     void SetVoBlockAckThreshold(uint8_t threshold);
     /**
      * Set the block ack threshold for AC_VI.
      *
-     * \param threshold the block ack threshold for AC_VI.
+     * @param threshold the block ack threshold for AC_VI.
      */
     void SetViBlockAckThreshold(uint8_t threshold);
     /**
      * Set the block ack threshold for AC_BE.
      *
-     * \param threshold the block ack threshold for AC_BE.
+     * @param threshold the block ack threshold for AC_BE.
      */
     void SetBeBlockAckThreshold(uint8_t threshold);
     /**
      * Set the block ack threshold for AC_BK.
      *
-     * \param threshold the block ack threshold for AC_BK.
+     * @param threshold the block ack threshold for AC_BK.
      */
     void SetBkBlockAckThreshold(uint8_t threshold);
 
     /**
      * Set VO block ack inactivity timeout.
      *
-     * \param timeout the VO block ack inactivity timeout.
+     * @param timeout the VO block ack inactivity timeout.
      */
     void SetVoBlockAckInactivityTimeout(uint16_t timeout);
     /**
      * Set VI block ack inactivity timeout.
      *
-     * \param timeout the VI block ack inactivity timeout.
+     * @param timeout the VI block ack inactivity timeout.
      */
     void SetViBlockAckInactivityTimeout(uint16_t timeout);
     /**
      * Set BE block ack inactivity timeout.
      *
-     * \param timeout the BE block ack inactivity timeout.
+     * @param timeout the BE block ack inactivity timeout.
      */
     void SetBeBlockAckInactivityTimeout(uint16_t timeout);
     /**
      * Set BK block ack inactivity timeout.
      *
-     * \param timeout the BK block ack inactivity timeout.
+     * @param timeout the BK block ack inactivity timeout.
      */
     void SetBkBlockAckInactivityTimeout(uint16_t timeout);
 
     /**
-     * \param mpdu the MPDU to send.
-     * \param to the address to which the packet should be sent.
-     * \param from the address from which the packet should be sent.
+     * @param mpdu the MPDU to send.
+     * @param to the address to which the packet should be sent.
+     * @param from the address from which the packet should be sent.
      *
      * Subclasses need to implement this method to finalize the MAC header of the MPDU
      * (MAC addresses and ToDS/FromDS flags) and enqueue the MPDU in a TX queue.
@@ -1149,12 +1181,21 @@
     /**
      * Allow subclasses to take actions when a packet to enqueue has been dropped.
      *
-     * \param packet the dropped packet
-     * \param to the address to which the packet should have been sent
+     * @param packet the dropped packet
+     * @param to the address to which the packet should have been sent
      */
     virtual void NotifyDropPacketToEnqueue(Ptr<Packet> packet, Mac48Address to);
 
     /**
+     * Notify the remote station manager if the given expired (hence dropped) MPDU is a management
+     * or data frame (with a unicast receiver address) that has been already transmitted and is not
+     * in flight (otherwise, it is handled when the ack is received or the TX timeout expires).
+     *
+     * @param mpdu the expired MPDU
+     */
+    void NotifyRsmOfExpiredMpdu(Ptr<const WifiMpdu> mpdu);
+
+    /**
      * This Boolean is set \c true iff this WifiMac is to model
      * 802.11e/WMM style Quality of Service. It is exposed through the
      * attribute system.
@@ -1200,10 +1241,13 @@
     uint32_t m_beMaxAmpduSize; ///< maximum A-MPDU size for AC_BE (in bytes)
     uint32_t m_bkMaxAmpduSize; ///< maximum A-MPDU size for AC_BK (in bytes)
 
-    uint16_t m_mpduBufferSize; //!< BlockAck buffer size (in number of MPDUs)
+    uint16_t m_mpduBufferSize;  //!< BlockAck buffer size (in number of MPDUs)
+    uint32_t m_frameRetryLimit; //!< the frame retry limit
 
     UniformRandomBitGenerator m_shuffleLinkIdsGen; //!< random number generator to shuffle link IDs
 
+    bool m_robustAVStreamingSupported; ///< flag whether robust AV streaming is supported
+
     /// @brief DL TID-to-Link Mapping negotiated with an MLD (identified by its MLD address)
     std::unordered_map<Mac48Address, WifiTidLinkMapping, WifiAddressHash> m_dlTidLinkMappings;
     /// @brief UL TID-to-Link Mapping negotiated with an MLD (identified by its MLD address)
@@ -1215,14 +1259,14 @@
      * The trace source fired when packets come into the "top" of the device
      * at the L3/L2 transition, before being queued for transmission.
      *
-     * \see class CallBackTraceSource
+     * @see class CallBackTraceSource
      */
     TracedCallback<Ptr<const Packet>> m_macTxTrace;
     /**
      * The trace source fired when packets coming into the "top" of the device
      * are dropped at the MAC layer before being queued for transmission.
      *
-     * \see class CallBackTraceSource
+     * @see class CallBackTraceSource
      */
     TracedCallback<Ptr<const Packet>> m_macTxDropTrace;
     /**
@@ -1230,7 +1274,7 @@
      * immediately before being forwarded up to higher layers (at the L2/L3
      * transition).  This is a promiscuous trace.
      *
-     * \see class CallBackTraceSource
+     * @see class CallBackTraceSource
      */
     TracedCallback<Ptr<const Packet>> m_macPromiscRxTrace;
     /**
@@ -1238,22 +1282,22 @@
      * immediately before being forwarded up to higher layers (at the L2/L3
      * transition).  This is a non- promiscuous trace.
      *
-     * \see class CallBackTraceSource
+     * @see class CallBackTraceSource
      */
     TracedCallback<Ptr<const Packet>> m_macRxTrace;
     /**
      * The trace source fired when packets coming into the "top" of the device
      * are dropped at the MAC layer during reception.
      *
-     * \see class CallBackTraceSource
+     * @see class CallBackTraceSource
      */
     TracedCallback<Ptr<const Packet>> m_macRxDropTrace;
 
     /**
      * TracedCallback signature for MPDU drop events.
      *
-     * \param reason the reason why the MPDU was dropped (\see WifiMacDropReason)
-     * \param mpdu the dropped MPDU
+     * @param reason the reason why the MPDU was dropped (\see WifiMacDropReason)
+     * @param mpdu the dropped MPDU
      */
     typedef void (*DroppedMpduCallback)(WifiMacDropReason reason, Ptr<const WifiMpdu> mpdu);
 
@@ -1274,9 +1318,9 @@
     /**
      * TracedCallback signature for MPDU response timeout events.
      *
-     * \param reason the reason why the timer was started
-     * \param mpdu the MPDU whose response was not received before the timeout
-     * \param txVector the TXVECTOR used to transmit the MPDU
+     * @param reason the reason why the timer was started
+     * @param mpdu the MPDU whose response was not received before the timeout
+     * @param txVector the TXVECTOR used to transmit the MPDU
      */
     typedef void (*MpduResponseTimeoutCallback)(uint8_t reason,
                                                 Ptr<const WifiMpdu> mpdu,
@@ -1295,9 +1339,9 @@
     /**
      * TracedCallback signature for PSDU response timeout events.
      *
-     * \param reason the reason why the timer was started
-     * \param psdu the PSDU whose response was not received before the timeout
-     * \param txVector the TXVECTOR used to transmit the PSDU
+     * @param reason the reason why the timer was started
+     * @param psdu the PSDU whose response was not received before the timeout
+     * @param txVector the TXVECTOR used to transmit the PSDU
      */
     typedef void (*PsduResponseTimeoutCallback)(uint8_t reason,
                                                 Ptr<const WifiPsdu> psdu,
@@ -1316,10 +1360,10 @@
     /**
      * TracedCallback signature for PSDU map response timeout events.
      *
-     * \param reason the reason why the timer was started
-     * \param psduMap the PSDU map for which not all responses were received before the timeout
-     * \param missingStations the MAC addresses of the stations that did not respond
-     * \param nTotalStations the total number of stations that had to respond
+     * @param reason the reason why the timer was started
+     * @param psduMap the PSDU map for which not all responses were received before the timeout
+     * @param missingStations the MAC addresses of the stations that did not respond
+     * @param nTotalStations the total number of stations that had to respond
      */
     typedef void (*PsduMapResponseTimeoutCallback)(uint8_t reason,
                                                    WifiPsduMap* psduMap,
@@ -1339,8 +1383,8 @@
     /**
      * TracedCallback signature for ICF drop events.
      *
-     * \param reason the reason why the ICF was dropped by the EMLSR client
-     * \param linkId the ID of the link on which the ICF was dropped
+     * @param reason the reason why the ICF was dropped by the EMLSR client
+     * @param linkId the ID of the link on which the ICF was dropped
      */
     typedef void (*IcfDropCallback)(WifiIcfDrop reason, uint8_t linkId);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-mac-header.cc ns-3.44/src/wifi/model/wifi-mac-header.cc
--- ns-3.43/src/wifi/model/wifi-mac-header.cc	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-mac-header.cc	2025-03-09 16:55:49.799372700 -0700
@@ -832,29 +832,25 @@
 bool
 WifiMacHeader::IsQosBlockAck() const
 {
-    NS_ASSERT(IsQosData());
-    return (m_qosAckPolicy == 3);
+    return (IsQosData() && m_qosAckPolicy == 3);
 }
 
 bool
 WifiMacHeader::IsQosNoAck() const
 {
-    NS_ASSERT(IsQosData());
-    return (m_qosAckPolicy == 1);
+    return (IsQosData() && m_qosAckPolicy == 1);
 }
 
 bool
 WifiMacHeader::IsQosAck() const
 {
-    NS_ASSERT(IsQosData());
-    return (m_qosAckPolicy == 0);
+    return (IsQosData() && m_qosAckPolicy == 0);
 }
 
 bool
 WifiMacHeader::IsQosEosp() const
 {
-    NS_ASSERT(IsQosData());
-    return (m_qosEosp == 1);
+    return (IsQosData() && m_qosEosp == 1);
 }
 
 WifiMacHeader::QosAckPolicy
@@ -886,8 +882,7 @@
 bool
 WifiMacHeader::IsQosAmsdu() const
 {
-    NS_ASSERT(IsQosData());
-    return (m_amsduPresent == 1);
+    return (IsQosData() && m_amsduPresent == 1);
 }
 
 uint8_t
@@ -1140,6 +1135,7 @@
            << ", SeqNumber=" << m_seqSeq;
         break;
     case WIFI_MAC_DATA:
+    case WIFI_MAC_QOSDATA:
         PrintFrameControl(os);
         os << " Duration/ID=" << m_duration << "us";
         if (!m_ctrlToDs && !m_ctrlFromDs)
@@ -1198,7 +1194,6 @@
     case WIFI_MAC_DATA_NULL_CFACK:
     case WIFI_MAC_DATA_NULL_CFPOLL:
     case WIFI_MAC_DATA_NULL_CFACK_CFPOLL:
-    case WIFI_MAC_QOSDATA:
     case WIFI_MAC_QOSDATA_CFACK:
     case WIFI_MAC_QOSDATA_CFPOLL:
     case WIFI_MAC_QOSDATA_CFACK_CFPOLL:
